package com.engine.forstarsecond.web;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.forstarsecond.service.ExamineRankingService;
import com.engine.forstarsecond.service.impl.ExamineRankingServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2025/4/27 10:04
 * @Description: TODO
 * @Version 1.0
 */
public class ExamineRankingAction {

    private ExamineRankingService getService(User user) {
        return ServiceUtil.getService(ExamineRankingServiceImpl.class, user);
    }

    @POST
    @Path("/examineRanking")
    @Produces(MediaType.TEXT_PLAIN)
    public String examineRanking(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.put("size", getService(user).examineRanking(ParamUtil.request2Map(request)));
            data.put("code", 200);
        } catch (Exception e) {
            data.put("code", 500);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }

    @GET
    @Path("/resourceImage")
    @Produces(MediaType.TEXT_PLAIN)
    public String resourceImage(@Context HttpServletRequest request, @Context HttpServletResponse response, @QueryParam("billid") String billid) {
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.putAll(getService(user).resourceImage(billid));
            data.put("code", 200);
        } catch (Exception e) {
            data.put("code", 500);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }

    @GET
    @Path("/workUnits")
    @Produces(MediaType.TEXT_PLAIN)
    public String workUnits(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.put("units",getService(user).workUnits());
            data.put("code", 200);
        } catch (Exception e) {
            data.put("code", 500);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }

    @GET
    @Path("/familyWorkUnit")
    @Produces(MediaType.TEXT_PLAIN)
    public String familyWorkUnit(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.put("unitList", getService(user).familyWorkUnit(ParamUtil.request2Map(request)));
            data.put("code", 200);
        } catch (Exception e) {
            data.put("code", 500);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data,SerializerFeature.DisableCircularReferenceDetect);
    }




}


