package com.weaver.formmode.customjavacode.forstarsecond;

import java.util.*;
import java.util.stream.Collectors;

import weaver.conn.RecordSetDataSource;
import weaver.formmode.customjavacode.AbstractCustomSqlConditionJavaCode;
import weaver.general.Util;


public class CustomSearchTemplate extends AbstractCustomSqlConditionJavaCode {

    /**
     * 生成SQL查询限制条件
     * @param param
     *  param包含(但不限于)以下数据
     *  user 当前用户
     *
     * @return
     *  返回的查询限制条件的格式举例为: t1.a = '1' and t1.b = '3' and t1.c like '%22%'
     *  其中t1为表单主表表名的别名
     */
    @Override
    public String generateSqlCondition(Map<String, Object> param) throws Exception {

        RecordSetDataSource rst = new RecordSetDataSource();
        List<String> unitList = new ArrayList<>();
        rst.executeQueryWithDatasource("select VndName from V_OA_BPVnd","psxt");
        while (rst.next()) {
            unitList.add(Util.null2String(rst.getString("VndName").trim()));
        }
        String join = unitList.stream()
                .map(s -> "'" + s + "'")
                .collect(Collectors.joining(","));
        rst.writeLog("CustomSearchTemplate："+unitList.toString());

        String sqlCondition = "d1.gzdw in ("+join+")";

        return sqlCondition;
    }

}
